//JWH / NOVEMBER 2000
//
//  WARNING: This code is NAMEWARE. Read below.
//
//     NAMEWARE is a quick 'fire and forget' process.
//     Before using this code for the first time, you *HAVE TO* send
//     a mail to: JEP-NWARE@ALTERN.ORG indicating your name, country
//     and everything  else you want. In return i will send you back
//     my  real name(*) and permission is  granted to use  this code
//     in any way you need.
//     (*) i know you don't care but that's the way it is.
//
//            +--------------------------------+
//            |                                |
//            |  Simple COM component - YES !  |
//            |                                |
//            +================================+
//
//
//  FUNCTIONALITIES / RESTRICTIONS:
//    VERY BASIC COM COMPONENT (far from an automation server)
//      NO Marshalling => InProcServer => DLL
//      NO AGGREGATION
//      NO IDispatch
//    Very small memory footprint (<10ko, thanks to LCC-WIN32)
//    Self register/unregister with extended support for CLSIDFromProgID
//    Multi-interface object
//    Easy to add new interface
//    Test (how to use) application
//
//  THIS FILE IS ONLY TEMPLATE CODE
//    Created under W2K, tested under W2K/W98SE/W95B but one never knowns...
//      please double-check before shipping.
//    When you will find bugs, please tell me. Also i would
//      appreciate receiving modifications & enhancements.
//
//  REMEMBER:
//    !! DO NOT USE THE IDs OF THIS FILE IN SHIPPING CODE !!
//    Generate IDs (CLSID and IID) *each time* you create
//    new components/interfaces. Use uuidgen.exe to do so.
//
//  COMPILE:
//    Launch LCC-WIN32 (build >= 17november2000 else add define in objbase.h (see iobject.h))
//    Create a new project: => DLL
//    Do not use the wizard, only add this file and make !
//    Linker option: *NO UNDERSCORE IN DLL EXPORTS*
//    Additionnal library: uuid.lib
//
//  REGISTER:
//    cd 'where the dll is'
//    regsvr32 iobject.dll  (you can add /s)
//  UNREGISTER:
//    cd 'where the dll is'
//    regsvr32 /u iobject.dll  (you can add /s)
//  regsvr32 is located in system or system32 directory
//
//  USAGE:
//    See tstiobject.c
//
//  CREATE A NEW COMPONENT FROM THIS FILE:
//    Generate new CLSID and IID(s)
//    Change filenames
//    Change szOBJECTNAME, szPROGID, szIIFn defines
//    Wherever you find IObject, Interf1, Interf2 set your own names
//    You can safely delete everything dealing with Interf2 if your
//      component needs only one interface. I2 is just here to show
//      how to backtrack to IObject and implement delegation.
//    Internal functions ARE NOT EXPOSED. You can safely leave I1QueryInterface, etc...
//    Follow COM rules. Well, I don't know them but you'd better study ! :-)
//
//  ADD A NEW INTERFACE:
//    Create an IID
//    #define INTERFACE in iobject.h
//    Add the interface in the IObject stucture
//      If needed, add attributs to the object structure
//    Modify I1QueryInterface to accept the new IID and set ppv accordingly
//    Write IUnknown methods (can use delegation to I1) [BackTrack to sruct]
//    Write specific methods
//    Declare & initialize vTable with your names for specifc methods
//    Add vTable pointer in the ClassFactory->CreateInstance
//      If needed, initialize new attributs in ClassFactory->CreateInstance
//    Add new Interface registry keys (optional) in DLLRegister/Unregister
//      (define a new szIIFn, and copy/modify existing code)
//
//  POINTERS (the only real utility of this file :)
//    http://msdn.microsoft.com/library/techart/msdn_com_co.htm
//    http://msdn.microsoft.com/workshop/default.asp
//    http://www.informit.com/  <==THIS ONE IS A VVEERRYY BIG SHOT
//                                (just register and you will see)
//  TODO (lot of):
//    Implement some OLE interfaces (IPersit* for example) to gain functionnalities
//    Implement marshalling, local server (.exe). Need MIDL for proxies/stub ?
//    Implement IDispatch (and TLB?) to instanciate from VB
//    Investigate DCOM
//
//  THANKS TO:
//    You
//    Jacob Navia
//    Crispin Goswell
//    Microsoft. Yes you read right.
//
//  Et voila.
//
#include <windows.h>
#include <objbase.h>
#include <initguid.h>

#define  IID_BOTH_MODE //We are in the IObject source file so we need static IDs even in EXTENDED_REG mode
#include "iobject.h"   //GUIDs and INTERFACES definitions

//Define CO_DEBUG to get a trace of component activity in log file
#define  CO_DEBUG
#ifdef   CO_DEBUG
#define  CO_DEBUG_LOG "co_debug.txt"
#include <stdio.h>
FILE *fin;
#endif

//GLOBAL OBJECT COUNTER
static int vcObjects = 0;
static int cfLock    = 0;

//Only for DLLRegisterServer to find its own path
HINSTANCE ghDLLInst;

//IObject instance data/////////////////////
typedef struct {
  IInterf1 iif1;
  IInterf2 iif2;
	int cRef;
	int value;
} IObject,*LPO;

//IOBJECT INTERFACE1 METHODS//////////////////////

//IUNKNOWN IMPLEMENTATION

static STDMETHODIMP I1QueryInterface(IInterf1 *pif, REFIID riid, void **ppv)
{
#ifdef CO_DEBUG
  fprintf(fin,"I1_QUERYINTERFACE IN %p\n",pif); fflush(fin);
#endif

	if(IsEqualIID(riid,&IID_IUnknown) || IsEqualIID(riid,&IID_Interf1)) {
		*ppv=pif;
    } else {
	  if(IsEqualIID(riid,&IID_Interf2)) {
		*ppv=&(((LPO)pif)->iif2);
	  } else {
	    *ppv=0;
	    return E_NOINTERFACE;
	  }
	}
	((LPUNKNOWN)*ppv)->lpVtbl->AddRef((LPUNKNOWN)*ppv);

#ifdef CO_DEBUG
    fprintf(fin,"I1_QUERYINTERFACE OUT %p %p\n",pif,*ppv); fflush(fin);
#endif

	return NOERROR;
}

static STDMETHODIMP_(ULONG) I1AddRef(IInterf1 *pif)
{
#ifdef CO_DEBUG
  fprintf(fin,"I1_ADDREF: %p %i\n",pif,(((LPO)pif)->cRef)+1); fflush(fin);
#endif

	return ++((LPO)pif)->cRef;
}

static STDMETHODIMP_(ULONG) I1Release(IInterf1 *pif)
{
#ifdef CO_DEBUG
  fprintf(fin,"I1_RELEASE: %p %i\n",pif,(((LPO)pif)->cRef)-1); fflush(fin);
#endif

    if(--((LPO)pif)->cRef == 0) {
	  --vcObjects;
	  LocalFree(pif);
	  return 0;
	}
	return ((LPO)pif)->cRef;
}

//OBJECT SPECIFIC METHODS

static STDMETHODIMP I1GetVersion(IInterf1 *pif, char *pValue)
{
	if(!pValue) return E_POINTER;
	strcpy(pValue,"JWH / v0.01");

#ifdef CO_DEBUG
  fprintf(fin,"I1_GETVERSION: %p %s\n",pif,pValue); fflush(fin);
#endif

	return NOERROR;
}

static STDMETHODIMP I1SetValue(IInterf1 *pif, int value)
{
	((LPO)pif)->value=value;

#ifdef CO_DEBUG
  fprintf(fin,"I1_SETVALUE: %p %i\n",pif,((LPO)pif)->value); fflush(fin);
#endif

	return NOERROR;
}

static STDMETHODIMP I1GetValue(IInterf1 *pif, int *pValue)
{
	if(!pValue) return E_POINTER;
	*pValue=((LPO)pif)->value;

#ifdef CO_DEBUG
  fprintf(fin,"I1_GETVALUE: %p %i\n",pif,*pValue); fflush(fin);
#endif

	return NOERROR;
}

static IInterf1Vtbl vtblI1 = {I1QueryInterface, I1AddRef, I1Release, I1GetVersion, I1SetValue, I1GetValue};

//INTERFACE 2 METHODS///////////////////////////////////////////////
//ALL BUT SQUAREVALUE ARE DELEGATED TO I1 ////////////////////////

//IUNKNOWN IMPLEMENTATION

static STDMETHODIMP I2QueryInterface(IInterf2 *pif, REFIID riid, void **ppv)
{
LPO this=(LPO)((BYTE*)pif-sizeof(IInterf1));   //Back track to Interface 1
                                               //Thanx Bill for the flat memory model !
#ifdef CO_DEBUG
  fprintf(fin,"I2_QUERYINTERFACE IN %p %p\n",pif,this); fflush(fin);
#endif

    return this->iif1.lpVtbl->QueryInterface(&this->iif1, riid, ppv);
}

static STDMETHODIMP_(ULONG) I2AddRef(IInterf2 *pif)
{
LPO this=(LPO)((BYTE*)pif-sizeof(IInterf1));   //Back track to Interface 1 !

#ifdef CO_DEBUG
  fprintf(fin,"I2_ADDREF: %p %p\n",pif,this); fflush(fin);
#endif

    return this->iif1.lpVtbl->AddRef(&this->iif1);
}

static STDMETHODIMP_(ULONG) I2Release(IInterf2 *pif)
{
LPO this=(LPO)((BYTE*)pif-sizeof(IInterf1));   //Back track to Interface 1 !

#ifdef CO_DEBUG
  fprintf(fin,"I2_RELEASE: %p %p\n",pif,this); fflush(fin);
#endif

    return this->iif1.lpVtbl->Release(&this->iif1);
}

//OBJECT SPECIFIC METHODS

static STDMETHODIMP I2SquareValue(IInterf2 *pif)
{
LPO this=(LPO)((BYTE*)pif-sizeof(IInterf1));   //Back track to OBJECT POINTER !

	((LPO)this)->value*=((LPO)this)->value;

#ifdef CO_DEBUG
  fprintf(fin,"I2_SQUAREVALUE: %p %p %i\n",pif,this,((LPO)this)->value); fflush(fin);
#endif

	return NOERROR;
}

static IInterf2Vtbl vtblI2 = {I2QueryInterface, I2AddRef, I2Release, I2SquareValue};

//CLASS FACTORY////////////////////////////////////////////////////////////////

//OBJECT CLASS FACTORY DEFINITION
typedef struct {
  IClassFactory icf;
  int cRef;
} CF, *LPCF;

static IClassFactory *vpcfOutside = NULL;

//OBJECT CLASS FACTORY METHODS
static STDMETHODIMP CFQueryInterface(IClassFactory *pcf, REFIID riid, void **ppv)
{
#ifdef CO_DEBUG
  fprintf(fin,"CF_QUERYINTERFACE IN %p\n",pcf); fflush(fin);
#endif

  if(IsEqualIID(riid, &IID_IUnknown) || IsEqualIID(riid, &IID_IClassFactory)) {
	*ppv=pcf;
  } else {
    *ppv = 0;
    return E_NOINTERFACE;
  }
  ((LPUNKNOWN)*ppv)->lpVtbl->AddRef((LPUNKNOWN)*ppv);

#ifdef CO_DEBUG
  fprintf(fin,"CF_QUERYINTERFACE OUT %p %p\n",pcf,*ppv); fflush(fin);
#endif

    return NOERROR;
}

static STDMETHODIMP_(ULONG) CFAddRef(IClassFactory *pcf)
{
#ifdef CO_DEBUG
  fprintf(fin,"CF_ADDREF: %p %i\n",pcf,(((LPCF)pcf)->cRef)+1);fflush(fin);
#endif

    return ++((LPCF)pcf)->cRef;
}

static STDMETHODIMP_(ULONG) CFRelease(IClassFactory *pcf)
{
#ifdef CO_DEBUG
  fprintf(fin,"CF_RELEASE: %p %i\n",pcf,(((LPCF)pcf)->cRef)-1);fflush(fin);
#endif

    if(--((LPCF)pcf)->cRef == 0)
      {
        LocalFree(pcf);
		vpcfOutside = NULL;
        return 0;
      }

    return ((LPCF)pcf)->cRef;
}

//THE OBJECT CREATOR (class factory CREATEINSTANCE member)

static STDMETHODIMP CFCreateObject(IClassFactory *pcf, IUnknown *punkOuter, REFIID riid, void **ppv)
{
HRESULT hr;
IObject *this;

#ifdef CO_DEBUG
  fprintf(fin,"CF_OBJCREATE IN\n");fflush(fin);
#endif

	*ppv=0;
	if(punkOuter) return CLASS_E_NOAGGREGATION;

    if(NULL==(this=LocalAlloc(LMEM_FIXED,sizeof(IObject)))) return E_OUTOFMEMORY;

	//Bump up global object count to keep DLL in memory
	++vcObjects;
    //Set up object's vTables
 	this->iif1.lpVtbl=&vtblI1;
 	this->iif2.lpVtbl=&vtblI2;
	//Set up count ref to allow self destruction if QueryInterface goes wrong
	this->cRef=1;
	//Initialize object's internal attributs
	this->value=0;

	//Ask for the required interface
	hr=this->iif1.lpVtbl->QueryInterface(&this->iif1,riid,ppv);
	//DONT CALL RELEASE THROUGH ppv because QueryInterface can fail !!!
	this->iif1.lpVtbl->Release(&this->iif1);  //If no PB cRef is back to 1, else object is destroyed

#ifdef CO_DEBUG
  fprintf(fin,"OBJ_CREATE OUT %p %p %li\n",this,*ppv,hr);fflush(fin);
#endif

		return hr;
}

static STDMETHODIMP CFLockServer(IClassFactory *pcf, BOOL flock)
{
    if(flock) ++cfLock;
      else --cfLock;

#ifdef CO_DEBUG
  fprintf(fin,"CF_LOCKSERVER %i\n",cfLock);fflush(fin);
#endif

    return NOERROR;
}

static IClassFactoryVtbl vtblClassFactory = {CFQueryInterface,CFAddRef,CFRelease,CFCreateObject,CFLockServer };

//CLASS FACTORY CREATOR
static STDMETHODIMP CFCreate(REFIID riid, void **ppv)
{
  CF *this;
  HRESULT hr;

    *ppv = 0;

#ifdef CO_DEBUG
  fprintf(fin,"CF_CREATE IN\n");fflush(fin);
#endif

    if(NULL==(this=LocalAlloc(LMEM_FIXED,sizeof(CF)))) return E_OUTOFMEMORY;

    this->icf.lpVtbl = &vtblClassFactory;
    this->cRef = 1;

    hr = this->icf.lpVtbl->QueryInterface(&this->icf, riid, ppv);
    this->icf.lpVtbl->Release(&this->icf);  //If no PB cRef is back to 1, else object is destroyed

#ifdef CO_DEBUG
  fprintf(fin,"CF_CREATE OUT %p %p %li\n",this,*ppv,hr);fflush(fin);
#endif

    return hr;
}

//DLL REQUIRED EXPORTS

STDAPI __declspec(dllexport) DllGetClassObject(REFCLSID rclsid, REFIID riid, void **ppv)
{
HRESULT hr;

#ifdef CO_DEBUG
  fprintf(fin,"DLL_GETCLASSOBJECT IN\n"); fflush(fin);
#endif

    *ppv = 0;
    if(IsEqualCLSID(rclsid, &CLSID_IObject)) {
      if(!vpcfOutside) {  //If no ClassFActory object exists yet
           hr=CFCreate(riid, &vpcfOutside);

#ifdef CO_DEBUG
  fprintf(fin,"DLL_GETCLASSOBJECT 1ST OUT %p %li\n",vpcfOutside,hr);fflush(fin);
#endif
           if(hr == NOERROR) *ppv=vpcfOutside;
		   return hr;
      }

	  hr=vpcfOutside->lpVtbl->QueryInterface(vpcfOutside, riid, ppv);

#ifdef CO_DEBUG
  fprintf(fin,"DLL_GETCLASSOBJECT OUT %p %li\n",*ppv,hr);fflush(fin);
#endif

	  return hr;
    }

#ifdef CO_DEBUG
  fprintf(fin,"DLL_GETCLASSOBJECT OUT WRONG CLSID\n"); fflush(fin);
#endif

    return E_FAIL;
}

STDAPI __declspec(dllexport) DllCanUnloadNow(void)
{
#ifdef CO_DEBUG
  fprintf(fin,"DLL_CANUNLOAD %i %i\n",vcObjects,cfLock);fflush(fin);
#endif

    return ((vcObjects==0) && (cfLock==0) ? S_OK : S_FALSE);
}

//Called by regsvr32 to set up registry
STDAPI __declspec(dllexport) DllRegisterServer(void)
{
DWORD dwDisp;
HKEY  hkMain;
HKEY  hkClass;
HKEY  hkPath;
char szClassID[39];
char szPath[MAX_PATH];
HRESULT hr=NOERROR;
REFCLSID ri;

#ifdef EXTENDED_REG
  char szStr[MAX_NAMES_LEN];
  //NO ERROR CHECK IS DONE FOR THE FIRST ENTRIES BECAUSE IT DOESN'T PREVENT THE COMPONENT TO RUN
  //  but allow CLSIDFromProgID to retrieve GUIDs

  //Only the szPROGID is normally used, but setting the interfaces ID
  //  really separate the client from GUIDs wich is great (i think)
  //  However maybe i break a COM rule in doing this... so if you want,
  //  just remove the Interface keys and leave only the PROGID

  ri=&IID_Interf1;
  //CLSID to string. Doing this manualy avoid loading ole32.dll for StringFromCLSID
  wsprintf(szClassID, "{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
    ri->Data1, ri->Data2, ri->Data3, ri->Data4[0], ri->Data4[1], ri->Data4[2],
	ri->Data4[3], ri->Data4[4], ri->Data4[5], ri->Data4[6], ri->Data4[7]);
  WideCharToMultiByte(CP_ACP,0,szIIF1,-1,szStr,MAX_NAMES_LEN,NULL,NULL);

  if(RegCreateKeyEx(HKEY_CLASSES_ROOT, szStr, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkMain, &dwDisp)==ERROR_SUCCESS) {
    RegSetValueEx(hkMain, NULL, 0, REG_SZ, (CONST BYTE*)szOBJECTNAME, sizeof(szOBJECTNAME));
    if(RegCreateKeyEx(hkMain, "CLSID", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkClass, &dwDisp)==ERROR_SUCCESS) {
      RegSetValueEx(hkClass, NULL, 0, REG_SZ, (CONST BYTE*)szClassID, sizeof(szClassID));
	  RegCloseKey(hkClass);
	}
    RegCloseKey(hkMain);
  }

  ri=&IID_Interf2;
  wsprintf(szClassID, "{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
    ri->Data1, ri->Data2, ri->Data3, ri->Data4[0], ri->Data4[1], ri->Data4[2],
	ri->Data4[3], ri->Data4[4], ri->Data4[5], ri->Data4[6], ri->Data4[7]);
  WideCharToMultiByte(CP_ACP,0,szIIF2,-1,szStr,MAX_NAMES_LEN,NULL,NULL);

  if(RegCreateKeyEx(HKEY_CLASSES_ROOT, szStr, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkMain, &dwDisp)==ERROR_SUCCESS) {
    RegSetValueEx(hkMain, NULL, 0, REG_SZ, (CONST BYTE*)szOBJECTNAME, sizeof(szOBJECTNAME));
    if(RegCreateKeyEx(hkMain, "CLSID", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkClass, &dwDisp)==ERROR_SUCCESS) {
      RegSetValueEx(hkClass, NULL, 0, REG_SZ, (CONST BYTE*)szClassID, sizeof(szClassID));
	  RegCloseKey(hkClass);
	}
    RegCloseKey(hkMain);
  }
#endif

  ri=&CLSID_IObject;
  wsprintf(szClassID, "{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
    ri->Data1, ri->Data2, ri->Data3, ri->Data4[0], ri->Data4[1], ri->Data4[2],
	ri->Data4[3], ri->Data4[4], ri->Data4[5], ri->Data4[6], ri->Data4[7]);

#ifdef EXTENDED_REG
  WideCharToMultiByte(CP_ACP,0,szPROGID,-1,szStr,MAX_NAMES_LEN,NULL,NULL);
  if(RegCreateKeyEx(HKEY_CLASSES_ROOT, szStr, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkMain, &dwDisp)==ERROR_SUCCESS) {
    RegSetValueEx(hkMain, NULL, 0, REG_SZ, (CONST BYTE*)szOBJECTNAME, sizeof(szOBJECTNAME));
    if(RegCreateKeyEx(hkMain, "CLSID", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkClass, &dwDisp)==ERROR_SUCCESS) {
      RegSetValueEx(hkClass, NULL, 0, REG_SZ, (CONST BYTE*)szClassID, sizeof(szClassID));
	  RegCloseKey(hkClass);
	}
    RegCloseKey(hkMain);
  }
#endif

  //Get my path
  (void)GetModuleFileName(ghDLLInst,szPath,MAX_PATH);

#ifdef CO_DEBUG
  fprintf(fin,"DLL_REGISTER %s %s\n",szClassID, szPath); fflush(fin);
#endif

  //NOW ERRORS ARE CHECKED BECAUSE FOLLOWING KEYS ARE MANDATORY

  //Open "HKEY_CLASS_ROOT\CLSID"
  if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "CLSID", 0, KEY_ALL_ACCESS, &hkMain)==ERROR_SUCCESS) {

    //Add \HKEY_CLASSES_ROOT\CLSID\{...}
    if(RegCreateKeyEx(hkMain, szClassID, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkClass, &dwDisp)==ERROR_SUCCESS) {
        RegSetValueEx(hkClass, NULL, 0, REG_SZ, (CONST BYTE*)szOBJECTNAME, sizeof(szOBJECTNAME));
        //RegSetValueEx(hkClass, "AppID", 0, REG_SZ, (CONST BYTE*)szClassID, sizeof(szClassID));

	  // Add \...\{...}\InprocServer32
      if(RegCreateKeyEx(hkClass, "InprocServer32", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkPath, &dwDisp)==ERROR_SUCCESS) {
        RegSetValueEx(hkPath, NULL, 0, REG_SZ, (CONST BYTE*)szPath, strlen(szPath) + 1);
        RegCloseKey(hkPath);
	  } else hr=E_FAIL;

/*
#ifdef EXTENDED_REG
	  // Add \...\{...}\ProgID to allow ProgIDFromCLSID to work
	  if(RegCreateKeyEx(hkClass, "ProgID", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkPath, &dwDisp)==ERROR_SUCCESS) {
        RegSetValueEx(hkPath, NULL, 0, REG_SZ, (CONST BYTE*)szStr, strlen(szStr)+1);
        RegCloseKey(hkPath);
	  } else hr=E_FAIL;
#endif
*/
      RegCloseKey(hkClass);
    } else hr=E_FAIL;

    RegCloseKey(hkMain);
  } else hr=E_FAIL;

  MessageBox(NULL,"COM Component v0.01\t\nJwH / November 2000","REGISTERED",MB_ICONINFORMATION|MB_OK);
  return hr;
}

//Called by regsvr32 to clear registry
STDAPI __declspec(dllexport) DllUnregisterServer(void)
{
HKEY  hkMain;
HKEY  hkClass;
char szClassID[39];
HRESULT hr=NOERROR;
REFCLSID ri=&CLSID_IObject;
#ifdef EXTENDED_REG
char szStr[MAX_NAMES_LEN];
#endif

  wsprintf(szClassID, "{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
    ri->Data1, ri->Data2, ri->Data3, ri->Data4[0], ri->Data4[1], ri->Data4[2],
	ri->Data4[3], ri->Data4[4], ri->Data4[5], ri->Data4[6], ri->Data4[7]);

#ifdef CO_DEBUG
  fprintf(fin,"DLL_UNREGISTER %s\n",szClassID); fflush(fin);
#endif

#ifdef EXTENDED_REG
  //Delete HKEY_CLASS_ROOT\"PROGID"
  WideCharToMultiByte(CP_ACP,0,szPROGID,-1,szStr,MAX_NAMES_LEN,NULL,NULL);
  if(RegOpenKeyEx(HKEY_CLASSES_ROOT, szStr, 0, KEY_ALL_ACCESS, &hkMain)==ERROR_SUCCESS) {
	RegDeleteKey(hkMain,"CLSID");
	RegCloseKey(hkMain);
	RegDeleteKey(HKEY_CLASSES_ROOT,szStr);
  }

  //Delete HKEY_CLASS_ROOT\"IIF1"
  WideCharToMultiByte(CP_ACP,0,szIIF1,-1,szStr,MAX_NAMES_LEN,NULL,NULL);
  if(RegOpenKeyEx(HKEY_CLASSES_ROOT, szStr, 0, KEY_ALL_ACCESS, &hkMain)==ERROR_SUCCESS) {
	RegDeleteKey(hkMain,"CLSID");
	RegCloseKey(hkMain);
	RegDeleteKey(HKEY_CLASSES_ROOT,szStr);
  }
  //Delete HKEY_CLASS_ROOT\"IIF2"
  WideCharToMultiByte(CP_ACP,0,szIIF2,-1,szStr,MAX_NAMES_LEN,NULL,NULL);
  if(RegOpenKeyEx(HKEY_CLASSES_ROOT, szStr, 0, KEY_ALL_ACCESS, &hkMain)==ERROR_SUCCESS) {
	RegDeleteKey(hkMain,"CLSID");
	RegCloseKey(hkMain);
	RegDeleteKey(HKEY_CLASSES_ROOT,szStr);
  }
#endif

  //Delete HKEY_CLASS_ROOT\CLSID\...
  if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "CLSID", 0, KEY_ALL_ACCESS, &hkMain)==ERROR_SUCCESS) {
    //Open "HKEY_CLASS_ROOT\CLSID\{...}"
    if(RegOpenKeyEx(hkMain, szClassID, 0, KEY_ALL_ACCESS, &hkClass)==ERROR_SUCCESS) {
	  RegDeleteKey(hkClass,"InprocServer32");
	  //RegDeleteKey(hkClass,"ProgID");
	  RegCloseKey(hkClass);
    } else hr=E_FAIL;
	RegDeleteKey(hkMain,szClassID);
	RegCloseKey(hkMain);
  } else hr=E_FAIL;

  return hr;
}

BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
			ghDLLInst=hDLLInst;  //For DLLRegisterServer

#ifdef CO_DEBUG
  fin=fopen(CO_DEBUG_LOG,"w");
  fprintf(fin,"#JWH\nDLL_ATTACH\n");fflush(fin);
#endif
           break;

        case DLL_PROCESS_DETACH:

#ifdef CO_DEBUG
  fprintf(fin,"DLL_DETACH %i %i\n",vcObjects,cfLock);fflush(fin);
  fclose(fin);
#endif
          break;

        case DLL_THREAD_ATTACH:
            break;

        case DLL_THREAD_DETACH:
            break;
    }
    return TRUE;
}



//
// JWH
//
// I'm trying to free your mind.
// But I can only show you the door.
// --Morpheus, The Matrix
//
